"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Kinobi = void 0;
const nodes_1 = require("./nodes");
const visitors_1 = require("./visitors");
class Kinobi {
    constructor(idls, useDefaultVisitor = true) {
        this.rootNode = nodes_1.RootNode.fromProgramInputs(idls);
        if (useDefaultVisitor)
            this.update(new visitors_1.DefaultVisitor());
    }
    accept(visitor) {
        return this.rootNode.accept(visitor);
    }
    update(visitor) {
        const newRoot = this.rootNode.accept(visitor);
        (0, nodes_1.assertRootNode)(newRoot);
        this.rootNode = newRoot;
    }
    clone() {
        const newRoot = new nodes_1.RootNode(this.rootNode.programs);
        const kinobi = new Kinobi([]);
        kinobi.rootNode = newRoot;
        return kinobi;
    }
}
exports.Kinobi = Kinobi;
//# sourceMappingURL=Kinobi.js.map