"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.assertTypeBoolNode = exports.isTypeBoolNode = exports.TypeBoolNode = void 0;
const TypeNumberNode_1 = require("./TypeNumberNode");
class TypeBoolNode {
    constructor(options = {}) {
        var _a;
        this.nodeClass = 'TypeBoolNode';
        this.size = (_a = options.size) !== null && _a !== void 0 ? _a : new TypeNumberNode_1.TypeNumberNode('u8');
    }
    accept(visitor) {
        return visitor.visitTypeBool(this);
    }
    toString() {
        return `bool(${this.size.toString()})`;
    }
}
exports.TypeBoolNode = TypeBoolNode;
function isTypeBoolNode(node) {
    return !!node && node.nodeClass === 'TypeBoolNode';
}
exports.isTypeBoolNode = isTypeBoolNode;
function assertTypeBoolNode(node) {
    var _a;
    if (!isTypeBoolNode(node)) {
        throw new Error(`Expected TypeBoolNode, got ${(_a = node === null || node === void 0 ? void 0 : node.nodeClass) !== null && _a !== void 0 ? _a : 'null'}.`);
    }
}
exports.assertTypeBoolNode = assertTypeBoolNode;
//# sourceMappingURL=TypeBoolNode.js.map