"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.assertTypeOptionNode = exports.isTypeOptionNode = exports.TypeOptionNode = void 0;
const TypeNode_1 = require("./TypeNode");
const TypeNumberNode_1 = require("./TypeNumberNode");
class TypeOptionNode {
    constructor(item, options = {}) {
        var _a, _b, _c;
        this.nodeClass = 'TypeOptionNode';
        this.item = item;
        this.prefix = (_a = options.prefix) !== null && _a !== void 0 ? _a : new TypeNumberNode_1.TypeNumberNode('u8');
        this.fixed = (_b = options.fixed) !== null && _b !== void 0 ? _b : false;
        this.idlType = (_c = options.idlType) !== null && _c !== void 0 ? _c : 'option';
    }
    static fromIdl(idl) {
        const item = 'option' in idl ? idl.option : idl.coption;
        const defaultPrefix = new TypeNumberNode_1.TypeNumberNode('option' in idl ? 'u8' : 'u32');
        const defaultFixed = !('option' in idl);
        return new TypeOptionNode((0, TypeNode_1.createTypeNodeFromIdl)(item), {
            prefix: idl.prefix ? new TypeNumberNode_1.TypeNumberNode(idl.prefix) : defaultPrefix,
            fixed: idl.fixed !== undefined ? idl.fixed : defaultFixed,
            idlType: 'option' in idl ? 'option' : 'coption',
        });
    }
    accept(visitor) {
        return visitor.visitTypeOption(this);
    }
}
exports.TypeOptionNode = TypeOptionNode;
function isTypeOptionNode(node) {
    return !!node && node.nodeClass === 'TypeOptionNode';
}
exports.isTypeOptionNode = isTypeOptionNode;
function assertTypeOptionNode(node) {
    var _a;
    if (!isTypeOptionNode(node)) {
        throw new Error(`Expected TypeOptionNode, got ${(_a = node === null || node === void 0 ? void 0 : node.nodeClass) !== null && _a !== void 0 ? _a : 'null'}.`);
    }
}
exports.assertTypeOptionNode = assertTypeOptionNode;
//# sourceMappingURL=TypeOptionNode.js.map