"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.mainCase = exports.snakeCase = exports.kebabCase = exports.camelCase = exports.pascalCase = exports.titleCase = exports.capitalize = exports.readJson = void 0;
const fs_1 = require("fs");
function readJson(value) {
    return JSON.parse((0, fs_1.readFileSync)(value, 'utf-8'));
}
exports.readJson = readJson;
function capitalize(str) {
    if (str.length === 0)
        return str;
    return str.charAt(0).toUpperCase() + str.slice(1).toLowerCase();
}
exports.capitalize = capitalize;
function titleCase(str) {
    return str
        .replace(/([A-Z])/g, ' $1')
        .split(/[-_\s+.]/)
        .filter((word) => word.length > 0)
        .map(capitalize)
        .join(' ');
}
exports.titleCase = titleCase;
function pascalCase(str) {
    return titleCase(str).split(' ').join('');
}
exports.pascalCase = pascalCase;
function camelCase(str) {
    if (str.length === 0)
        return str;
    const pascalStr = pascalCase(str);
    return pascalStr.charAt(0).toLowerCase() + pascalStr.slice(1);
}
exports.camelCase = camelCase;
function kebabCase(str) {
    return titleCase(str).split(' ').join('-').toLowerCase();
}
exports.kebabCase = kebabCase;
function snakeCase(str) {
    return titleCase(str).split(' ').join('_').toLowerCase();
}
exports.snakeCase = snakeCase;
function mainCase(str) {
    return camelCase(str);
}
exports.mainCase = mainCase;
//# sourceMappingURL=utils.js.map