"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.toNodeSelectorFunction = void 0;
const nodes = __importStar(require("../nodes"));
const utils_1 = require("../utils");
const toNodeSelectorFunction = (selector) => {
    if (typeof selector === 'function')
        return selector;
    const checkType = (node) => {
        switch (selector.type) {
            case 'program':
                return nodes.isProgramNode(node);
            case 'instruction':
                return nodes.isInstructionNode(node);
            case 'account':
                return nodes.isAccountNode(node);
            case 'definedType':
                return nodes.isDefinedTypeNode(node);
            case 'error':
                return nodes.isErrorNode(node);
            case 'typeDefinedLink':
                return nodes.isTypeDefinedLinkNode(node);
            case 'typeStruct':
                return nodes.isTypeStructNode(node);
            case 'typeString':
                return nodes.isTypeStringNode(node);
            case 'typeNumber':
                return nodes.isTypeNumberNode(node);
            case '*':
            default:
                return true;
        }
    };
    const checkName = (node) => {
        if (selector.name === undefined)
            return true;
        return (0, utils_1.mainCase)(selector.name) === node.name;
    };
    const checkStack = (node, stack) => {
        if (selector.stack === undefined)
            return true;
        const selectorStack = Array.isArray(selector.stack)
            ? selector.stack
            : selector.stack.split('.');
        return stack.matchesWithNames(selectorStack);
    };
    const checkProgram = (node, stack, program) => {
        if (selector.program === undefined)
            return true;
        return !!program && (0, utils_1.mainCase)(selector.program) === program.name;
    };
    return (node, stack, program) => checkType(node, stack, program) &&
        checkName(node, stack, program) &&
        checkStack(node, stack, program) &&
        checkProgram(node, stack, program);
};
exports.toNodeSelectorFunction = toNodeSelectorFunction;
//# sourceMappingURL=NodeSelector.js.map