"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SetAccountDiscriminatorFromFieldVisitor = void 0;
const nodes = __importStar(require("../../nodes"));
const TransformNodesVisitor_1 = require("./TransformNodesVisitor");
class SetAccountDiscriminatorFromFieldVisitor extends TransformNodesVisitor_1.TransformNodesVisitor {
    constructor(map) {
        const transforms = Object.entries(map).map(([selectorStack, { field, value }]) => {
            const stack = selectorStack.split('.');
            const name = stack.pop();
            return {
                selector: { type: 'account', stack, name },
                transformer: (node) => {
                    nodes.assertAccountNode(node);
                    if (nodes.isTypeDefinedLinkNode(node.type))
                        return node;
                    const fieldIndex = node.type.fields.findIndex((f) => f.name === field);
                    if (fieldIndex < 0) {
                        throw new Error(`Account [${node.name}] does not have a field named [${field}].`);
                    }
                    const fieldNode = node.type.fields[fieldIndex];
                    return new nodes.AccountNode({
                        ...node.metadata,
                        discriminator: { kind: 'field', name: field },
                    }, new nodes.TypeStructNode(node.type.name, [
                        ...node.type.fields.slice(0, fieldIndex),
                        new nodes.TypeStructFieldNode({
                            ...fieldNode.metadata,
                            defaultsTo: { strategy: 'omitted', value },
                        }, fieldNode.type),
                        ...node.type.fields.slice(fieldIndex + 1),
                    ]));
                },
            };
        });
        super(transforms);
        this.map = map;
    }
}
exports.SetAccountDiscriminatorFromFieldVisitor = SetAccountDiscriminatorFromFieldVisitor;
//# sourceMappingURL=SetAccountDiscriminatorFromFieldVisitor.js.map