"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SetInstructionDiscriminatorsVisitor = void 0;
const nodes = __importStar(require("../../nodes"));
const TransformNodesVisitor_1 = require("./TransformNodesVisitor");
class SetInstructionDiscriminatorsVisitor extends TransformNodesVisitor_1.TransformNodesVisitor {
    constructor(map) {
        const transforms = Object.entries(map).map(([selectorStack, discriminator]) => {
            const stack = selectorStack.split('.');
            const name = stack.pop();
            return {
                selector: { type: 'instruction', stack, name },
                transformer: (node) => {
                    var _a, _b, _c, _d;
                    nodes.assertInstructionNode(node);
                    if (nodes.isTypeDefinedLinkNode(node.args))
                        return node;
                    const discriminatorField = new nodes.TypeStructFieldNode({
                        name: (_a = discriminator.name) !== null && _a !== void 0 ? _a : 'discriminator',
                        docs: (_b = discriminator.docs) !== null && _b !== void 0 ? _b : [],
                        defaultsTo: {
                            strategy: (_c = discriminator.strategy) !== null && _c !== void 0 ? _c : 'omitted',
                            value: discriminator.value,
                        },
                    }, (_d = discriminator.type) !== null && _d !== void 0 ? _d : new nodes.TypeNumberNode('u8'));
                    return new nodes.InstructionNode(node.metadata, node.accounts, new nodes.TypeStructNode(node.args.name, [
                        discriminatorField,
                        ...node.args.fields,
                    ]), node.subInstructions);
                },
            };
        });
        super(transforms);
        this.map = map;
    }
}
exports.SetInstructionDiscriminatorsVisitor = SetInstructionDiscriminatorsVisitor;
//# sourceMappingURL=SetInstructionDiscriminatorsVisitor.js.map