"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UpdateProgramsVisitor = void 0;
const nodes = __importStar(require("../../nodes"));
const TransformNodesVisitor_1 = require("./TransformNodesVisitor");
class UpdateProgramsVisitor extends TransformNodesVisitor_1.TransformNodesVisitor {
    constructor(map) {
        const transforms = Object.entries(map).map(([name, updates]) => ({
            selector: { type: 'program', name },
            transformer: (node, stack, program) => {
                nodes.assertProgramNode(node);
                if (typeof updates === 'function') {
                    return updates(node, stack, program);
                }
                if ('delete' in updates) {
                    return null;
                }
                return new nodes.ProgramNode({ ...node.metadata, ...updates }, node.accounts, node.instructions, node.definedTypes, node.errors);
            },
        }));
        super(transforms);
        this.map = map;
    }
}
exports.UpdateProgramsVisitor = UpdateProgramsVisitor;
//# sourceMappingURL=UpdateProgramsVisitor.js.map