import type { IdlTypeMap } from '../idl';
import type { Visitable, Visitor } from '../visitors';
import type { Node } from './Node';
import { TypeNode } from './TypeNode';
import { TypeNumberNode } from './TypeNumberNode';
export declare class TypeMapNode implements Visitable {
    readonly nodeClass: "TypeMapNode";
    readonly key: TypeNode;
    readonly value: TypeNode;
    readonly size: {
        kind: 'fixed';
        size: number;
    } | {
        kind: 'prefixed';
        prefix: TypeNumberNode;
    } | {
        kind: 'remainder';
    };
    readonly idlType: 'hashMap' | 'bTreeMap';
    constructor(key: TypeNode, value: TypeNode, options?: {
        size?: TypeMapNode['size'];
        idlType?: 'hashMap' | 'bTreeMap';
    });
    static fromIdl(idl: IdlTypeMap): TypeMapNode;
    accept<T>(visitor: Visitor<T>): T;
}
export declare function isTypeMapNode(node: Node | null): node is TypeMapNode;
export declare function assertTypeMapNode(node: Node | null): asserts node is TypeMapNode;
