import type { Visitable, Visitor } from '../visitors';
import type { Node } from './Node';
export type NumberFormat = 'u8' | 'u16' | 'u32' | 'u64' | 'u128' | 'i8' | 'i16' | 'i32' | 'i64' | 'i128' | 'f32' | 'f64';
export declare class TypeNumberNode implements Visitable {
    readonly nodeClass: "TypeNumberNode";
    readonly format: NumberFormat;
    readonly endian: 'le' | 'be';
    constructor(format: NumberFormat, options?: {
        endian?: 'le' | 'be';
    });
    accept<T>(visitor: Visitor<T>): T;
    isSignedInteger(): boolean;
    isUnsignedInteger(): boolean;
    isInteger(): boolean;
    isDecimal(): boolean;
    toString(): string;
}
export declare function isTypeNumberNode(node: Node | null): node is TypeNumberNode;
export declare function assertTypeNumberNode(node: Node | null): asserts node is TypeNumberNode;
