import type { Visitable, Visitor } from '../visitors';
import type { Node } from './Node';
import { TypeNumberNode } from './TypeNumberNode';
export declare class TypeStringNode implements Visitable {
    readonly nodeClass: "TypeStringNode";
    readonly size: {
        kind: 'fixed';
        bytes: number;
    } | {
        kind: 'prefixed';
        prefix: TypeNumberNode;
    } | {
        kind: 'variable';
    };
    readonly encoding: 'utf8' | 'base16' | 'base58' | 'base64';
    constructor(options?: {
        size?: TypeStringNode['size'];
        encoding?: TypeStringNode['encoding'];
    });
    accept<T>(visitor: Visitor<T>): T;
    getSizeAsString(): string;
    toString(): string;
}
export declare function isTypeStringNode(node: Node | null): node is TypeStringNode;
export declare function assertTypeStringNode(node: Node | null): asserts node is TypeStringNode;
