import type { IdlTypeStruct } from '../idl';
import type { Visitable, Visitor } from '../visitors';
import type { Node } from './Node';
import { TypeStructFieldNode } from './TypeStructFieldNode';
export declare class TypeStructNode implements Visitable {
    readonly nodeClass: "TypeStructNode";
    readonly name: string;
    readonly fields: TypeStructFieldNode[];
    constructor(name: string, fields: TypeStructFieldNode[]);
    static fromIdl(idl: IdlTypeStruct): TypeStructNode;
    accept<T>(visitor: Visitor<T>): T;
}
export declare function isTypeStructNode(node: Node | null): node is TypeStructNode;
export declare function assertTypeStructNode(node: Node | null): asserts node is TypeStructNode;
