import * as nodes from '../nodes';
import type { NodeStack } from './NodeStack';
export type NodeSelectorType = 'program' | 'instruction' | 'account' | 'definedType' | 'error' | 'typeDefinedLink' | 'typeStruct' | 'typeString' | 'typeNumber';
export type NodeSelector = {
    type: NodeSelectorType | '*';
    name?: string;
    stack?: string | string[];
    program?: string;
} | NodeSelectorFunction;
export type NodeSelectorFunction = (node: nodes.Node, stack: NodeStack, program: nodes.ProgramNode | null) => boolean;
export declare const toNodeSelectorFunction: (selector: NodeSelector) => NodeSelectorFunction;
