import * as nodes from '../../nodes';
import { Visitor } from '../Visitor';
export type DefinedTypeHistogram = {
    [key: string]: {
        total: number;
        inAccounts: number;
        inDefinedTypes: number;
        inInstructionArgs: number;
        directlyAsInstructionArgs: number;
    };
};
export declare class GetDefinedTypeHistogramVisitor implements Visitor<DefinedTypeHistogram> {
    private mode;
    private stackLevel;
    visitRoot(root: nodes.RootNode): DefinedTypeHistogram;
    visitProgram(program: nodes.ProgramNode): DefinedTypeHistogram;
    visitAccount(account: nodes.AccountNode): DefinedTypeHistogram;
    visitInstruction(instruction: nodes.InstructionNode): DefinedTypeHistogram;
    visitDefinedType(definedType: nodes.DefinedTypeNode): DefinedTypeHistogram;
    visitError(): DefinedTypeHistogram;
    visitTypeArray(typeArray: nodes.TypeArrayNode): DefinedTypeHistogram;
    visitTypeDefinedLink(typeDefinedLink: nodes.TypeDefinedLinkNode): DefinedTypeHistogram;
    visitTypeEnum(typeEnum: nodes.TypeEnumNode): DefinedTypeHistogram;
    visitTypeEnumEmptyVariant(): DefinedTypeHistogram;
    visitTypeEnumStructVariant(typeEnumStructVariant: nodes.TypeEnumStructVariantNode): DefinedTypeHistogram;
    visitTypeEnumTupleVariant(typeEnumTupleVariant: nodes.TypeEnumTupleVariantNode): DefinedTypeHistogram;
    visitTypeMap(typeMap: nodes.TypeMapNode): DefinedTypeHistogram;
    visitTypeOption(typeOption: nodes.TypeOptionNode): DefinedTypeHistogram;
    visitTypeSet(typeSet: nodes.TypeSetNode): DefinedTypeHistogram;
    visitTypeStruct(typeStruct: nodes.TypeStructNode): DefinedTypeHistogram;
    visitTypeStructField(typeStructField: nodes.TypeStructFieldNode): DefinedTypeHistogram;
    visitTypeTuple(typeTuple: nodes.TypeTupleNode): DefinedTypeHistogram;
    visitTypeBool(): DefinedTypeHistogram;
    visitTypeBytes(): DefinedTypeHistogram;
    visitTypeNumber(): DefinedTypeHistogram;
    visitTypeNumberWrapper(typeNumberWrapper: nodes.TypeNumberWrapperNode): DefinedTypeHistogram;
    visitTypePublicKey(): DefinedTypeHistogram;
    visitTypeString(): DefinedTypeHistogram;
    protected mergeHistograms(histograms: DefinedTypeHistogram[]): DefinedTypeHistogram;
}
