import type * as nodes from '../../nodes';
import { BaseThrowVisitor } from '../BaseThrowVisitor';
export type ResolvedInstructionAccount = nodes.InstructionNodeAccount & {
    position: number;
    dependencyPosition: number;
    dependsOn: string[];
    resolvedIsSigner: boolean;
    resolvedIsOptionalSigner: boolean;
    resolvedIsOptional: boolean;
};
export declare class GetResolvedInstructionAccountsVisitor extends BaseThrowVisitor<ResolvedInstructionAccount[]> {
    protected stack: string[];
    protected visited: Map<string, ResolvedInstructionAccount>;
    protected raw: Map<string, [nodes.InstructionNodeAccount, number]>;
    protected error: string | null;
    getError(): string | null;
    visitInstruction(instruction: nodes.InstructionNode): ResolvedInstructionAccount[];
    handleInstructionAccount(instruction: nodes.InstructionNode, account: nodes.InstructionNodeAccount, index: number): void;
}
